#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*ordinamento alfabetico di n stringhe in una coda*/

struct Coda{
 char *nome;
 struct Coda *next;
};

typedef struct Coda coda;


coda* elimina(coda *q, char *s);/*elimina s in q*/
coda* elimina_primo(coda *q);
char* minima(coda *q);/*restituisce la stringa minima in ordine alfabetico in q*/
int min(coda *q, char *s);/*1 se s è il minimo alfabetico di q, 0 altrimenti*/
void stampa(coda *q);	
coda* ordina(coda *q);/*ordina la coda q*/
coda* inserisci_in_fondo(coda *q, char *s);




int main ()
{  
   int dim=15;
   int j;
   int N=5;
   char s[dim];
   coda *q;
   q=malloc(sizeof(coda));
   q=NULL;
for(j=0;j<N;j++)
   
   {
   printf("\n inserisci una stringa\n\n");
   fgets(s,dim,stdin);
   q=inserisci_in_fondo(q,s);}

   
printf("\n\n\n");
stampa(q); 
printf("\n\n\n");
q=ordina(q);
stampa(q);

   
   return 0;
}


int min(coda *q, char *s)
{
int m=1;
if(q!=NULL)
{
 if (strcmp(s, q->nome)>0)
 {
  m=0;
 }
else m=min(q->next,s);
 }
return m;
}



char* minima(coda *q)
{
char *s;
if(q!=NULL)
{
  s=q->nome;
  if (min(q,s)==1)
  return s;
  else
   { q=q->next;
     s=minima(q);
     return s;
    }
 } 
}



coda* elimina(coda *q, char *s)/*elimina s in q*/
{
 if(q!=NULL)
 {
   if(strcmp(q->nome,s)==0)  q=elimina_primo(q);
   else q->next=elimina(q->next,s);
  }
return q;
}



coda* ordina(coda *q)

{
coda *temp;
temp=malloc(sizeof(coda));
temp=NULL;
while(q!=NULL)
 {
 temp=inserisci_in_fondo(temp,minima(q));
 q=elimina(q,minima(q));
 }
return temp; 
 }



coda* elimina_primo(coda *q)
{
coda *temp;
temp=malloc(sizeof(coda));
temp=q;
q=q->next;
free(temp);
return q;
}


coda* inserisci_in_fondo(coda *q, char *s)
{
 if(q==NULL)
 {q=malloc(sizeof(coda));
q->nome=s;
 q->next=NULL;
 return q;
  }
else {q->next=inserisci_in_fondo(q->next,s);
      return q;}

}


void stampa(coda *q)
{
  while(q!=NULL)
{printf("%s\n", q->nome);
 q=q->next; }

}


