#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define dim 100

struct Coda{
 char *nome;
 struct Coda *next;
};

typedef struct Coda coda;

coda* inserisci_in_fondo(coda *q, char *s);
coda* inserisci_in_testa(coda *q, char *s);
void stampa(coda *q);
coda* elimina_primo(coda *q);
coda* ordina(coda *q);
char* min(coda *q);
coda* elimina(coda *q, char *s);


int main()
{
coda *q;
char *s;
int e;
q=malloc(sizeof(coda));
q=NULL;
s=(char*)malloc(dim*sizeof(char));
scanf("%d",&e);
while(e!=0)
 {
   if(e==1)
       {
       fgets(s,dim,stdin);
       q=inserisci_in_fondo(q,s);
        }
   else if(e==2)
        {
         q=elimina_primo(q);
        }
  scanf("%d",&e);
  }
q=ordina(q);
stampa(q);
return 0;
}


coda* elimina(coda *q, char *s)/*elimina s in q*/
{
 if(q!=NULL)
 {
   if(strcmp(q->nome,s)==0)  q=elimina_primo(q);
   else q->next=elimina(q->next,s);
  }
return q;
}


char* min(coda *q)
{
char *min;
min=q->nome;
q=q->next;
while(q!=NULL)
  { 
    if(strcmp(min,q->nome)>0){min=q->nome; q=q->next; }
    else q=q->next;
   }
return min;
}




coda* ordina(coda *q)
{
coda *temp;
temp=malloc(sizeof(coda));
while(q!=NULL)
  { 
    temp=inserisci_in_fondo(q,min(q));
    q=elimina(q,min(q));
   }

return temp;
}



coda* elimina_primo(coda *q)
{
coda *temp;
temp=malloc(sizeof(coda));
temp=q;
q=q->next;
free(temp);
return q;
}





void stampa(coda *q)
{
  while(q!=NULL)
{printf("%s\n", q->nome);
 q=q->next; }
printf("$\n");
}




coda* inserisci_in_fondo(coda *q, char *s)
{
 if(q==NULL)
 {q=malloc(sizeof(coda));
q->nome=s;
 q->next=NULL;
 return q;
  }
else {q->next=inserisci_in_fondo(q->next,s);
      return q;}

}


coda* inserisci_in_testa(coda *q, char *s)
{
coda *temp;
temp=malloc(sizeof(coda));
temp->nome=s;
temp->next=q;
return temp;
}
