#include <stdio.h>
#include <stdlib.h>

/*lista concatenata di interi positivi, 3 funzioni che aggiungono un elemento in fondo alla lista, aggiungono un elem in cima alla lista, dato un valore positivo m elimina la prima occorrenza di m (+funzione stampare la lista). nel main si leggono interi: se v<0 rimuovere il primo elemento uguale a -v dalla lista, se v è positivo e pari aggiungerlo in cima alla lista, se positivo e dispari in fondo alla lista, se è 0 terminare l'esecuzione del programma e stampare la lista*/

struct lista{
       int info;
       struct lista *next;
};

typedef struct lista Lista;

void stampalista(Lista *l); /*stampa la lista*/
Lista* inserisci_in_testa(Lista *l, int m);/*inserisce m in testa alla lista*/
Lista* inserisci_in_coda(Lista *l, int m);/*inserisce m in fondo alla lista*/
void cancella_lista(Lista *l);
int ricerca_elem(Lista *l, int m);



int main()
{
 Lista *l=NULL;
 int v;
 printf("\ninserisci un intero\n");
 scanf("%d", &v);
if(v==0)
{return;}
else if (v<0){while(v<0) {
      printf("\ninserisci un intero\n");
      scanf("%d", &v);}}
else
{ 
l=(Lista*)malloc(sizeof(Lista));
l->info=v;
l->next=NULL;
}
printf("\ninserisci un intero\n");
scanf("%d", &v);
while(v>0)
{
 
if(v%2==0)
     {l=inserisci_in_testa(l,v);}
else
     {l=inserisci_in_coda(l,v);}
printf("\ninserisci un intero\n");
scanf("%d", &v);
}
stampalista(l); 
return 0; 
}



void stampalista(Lista *l )
{ 
if(l!=NULL)
{printf("\n%d\n",l->info );
stampalista(l->next);
}}

Lista *inserisci_in_testa(Lista *l, int m)
{
 Lista *temp;
 temp=(Lista*)malloc(sizeof(Lista));
 temp->info=m;
 temp->next=l;
 return temp;
}

Lista *inserisci_in_coda(Lista *l, int m)
{
  Lista *temp;
  if(l==NULL)
{ 
  temp=(Lista*)malloc(sizeof(Lista));
  temp->info=m;
  temp->next=NULL;
  return temp;
}
 else
 { 
 l->next=inserisci_in_coda(l->next,m);
 return l;
 }
}

void cancella_lista(Lista *l)
{ 
  Lista *temp;
  while(l!=NULL)
{
temp=l;
l=l->next;
free(temp);
}
}


int ricerca_elem(Lista *l, int m)/*restituisce 1 se m appartiene alla lista, 1 altrimenti*/
{
 int trovato=0;
while(l!=NULL&& !trovato)
{if(l->info==m)
trovato=1;
else l=l->next;

return trovato;
}
}



Lista *prima_occorrenza(Lista *l, int m)
{
 Lista *temp;
 if(l==NULL)
return;
else if(l->info==m)
 {
 temp=l;
 l=l->next;
 free(temp);
return l;
 }
else
 return prima_occorrenza(l->next,m);
}
