#include <stdio.h>
#include <stdlib.h>

struct lista{
 int info;
 struct lista *next;
 };

typedef struct lista Lista;

Lista* crea();
void stampa(Lista *l);
Lista* cancellaprimo(Lista *l);
Lista* prima_occorrenza(Lista *l, int m);/*cancella la prima occorrenza di m in l*/
Lista* cancella_elemento(Lista *l, int m);/*cancella tutte le occorrenze di m in l*/
int trovato(Lista *l,int m);/*restituisce 1 se m è presente in l e 0 altrimenti*/
Lista* elimina_doppie(Lista *l); /*restituisceuna lista senza elementi presenti in più di una copia*/



int main()
{
Lista *l;
l=crea();
l=elimina_doppie(l);
stampa(l);
return 0;
 }

Lista* elimina_doppie(Lista *l)
{

Lista *temp;
if(l!=NULL)
 {
l->next=cancella_elemento(l->next,l->info);
l->next=elimina_doppie(l->next);
return l;
 }
}

int trovato(Lista *l,int m)
{
int trovato=0;
while(trovato==0&&l!=NULL)
{
if(l->info==m)
 {
trovato=1;
 }
else {l=l->next;}
 }
return trovato;
}

Lista* cancella_elemento(Lista *l, int m)
{
 while(l!=NULL&&trovato(l,m)==1)
 {l=prima_occorrenza(l,m);}
return l;
}

Lista* cancellaprimo(Lista *l)
{
Lista *temp;
temp=l;
l=l->next;
free(temp);
return l;
}

Lista* prima_occorrenza(Lista *l, int m)
{
if(l!=NULL)
{
 if(l->info==m) {l=cancellaprimo(l);}
else {l->next=prima_occorrenza(l->next,m); }
}
return l;

 }

Lista* crea()
{
Lista *l,*temp;
int i,n;
printf("\nnumero elementi\n");
scanf("%d",&n);
l=malloc(sizeof(Lista));
if(n==0)
l=NULL;
else 
{
 printf("inserisci il primo valore \n");
 scanf("%d",&l->info);
 l->next=NULL;
 temp=l;
  for(i=2;i<=n;i++)
  {
   temp->next=malloc(sizeof(Lista));
   temp=temp->next;
   printf("\ninserisci il %d valore",i);
   scanf("%d",&temp->info);
  }
 temp->next=NULL;
}
 return l;
 }



void stampa(Lista *l)
{
 if(l!=NULL)
{printf("\n%d\n",l->info);
stampa(l->next);}
}
