#include <stdio.h>
#include <stdlib.h>

struct lista{ int info;
 struct lista *next;
};

typedef struct lista Lista;



Lista* elimina_doppie(Lista *l);
Lista *elimina(Lista *l, int n);
void *prima_occorrenza(Lista *l, int m);
void stampa(Lista *l);
Lista *crea_lista();

int main()
{
Lista *l=crea_lista();
l=elimina_doppie(l);
stampa(l);
}




Lista *crea_lista()
{ 
 Lista *p, *punt;
int i,n;
printf("\nspecificare il numero degli elementi\n");
scanf("%d", &n);
 if(n==0)
 p=NULL;
 
else
 {
p=(Lista*)malloc(sizeof(Lista));
printf("\ninserisci il primo valore\n");
scanf("%d", &p->info);
punt=p;
for(i=2;i<=n;i++)
{ 
 punt->next=(Lista*)malloc(sizeof(Lista));
 punt=punt->next;
 printf("\ninserisci il %d elemento ", i);
 scanf("%d", &punt->info);
}
punt->next=NULL;
} 
return p;
}




void stampa(Lista *l)
{
if(l!=NULL)
{printf("\n%d\n", l->info);
 stampa(l->next);
}
}

Lista *elimina(Lista *l, int n)/*elimina tutte le occorrenze di n*/
{ 
Lista *temp;
temp=malloc(sizeof(Lista));
temp=l;
while(temp!=NULL)
{prima_occorrenza(temp,n);
temp=temp->next;
}
return l;
}



void prima_occorrenza(Lista *l, int m)

{
 Lista *temp,*precedente,*corrente;
 int trovato=0;
 if(l==NULL)
return;
else if(l->info==m)
 {
 temp=l;
 l=l->next;
 free(temp);
 }
else
 {  
   precedente=l;
   corrente=l->next;
  while(!trovato && corrente!=NULL)
 {if(corrente->info==m)
 {
  trovato=1; 
  precedente->next=corrente->next;
  free(corrente);
  }
else {
 precedente=precedente->next;
 corrente=corrente->next;
    }
   }
 }
}






Lista* elimina_doppie(Lista *l) /*elimina gli elementi presenti in più di una copia nella lista*/
{
 Lista *temp;
 temp=l;
while(temp!=NULL)
{
 temp=elimina(temp->next, temp->info);
 temp=temp->next;
}
return l;
}
