#include <stdio.h>
#include <stdlib.h>

struct lista{ int info;
 struct lista *next;
};

typedef struct lista Lista;

Lista *crea_lista();
void stampa(Lista *l);
int min(Lista *l, int m); /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/
Lista* ordina(Lista *l, int m);
Lista* inserisci_in_testa(Lista *l, int m);
int main()
{

Lista *l;
int n;
l=crea_lista();
printf("\ninserisci un elemento e inseriamolo ordinat\n");
scanf("%d", &n);
l=ordina(l,n);
stampa(l);
return 0;
}

Lista* ordina(Lista *l, int m)
{
if(l!=NULL)
 {if(min(l,m)==1)
{l=inserisci_in_testa(l,m);}
else {l->next=ordina(l->next,m);}
}
else{l=malloc(sizeof(Lista));
l->info=m; l->next=NULL; }
return l;
}

Lista* inserisci_in_testa(Lista *l, int m)
{
Lista *temp=malloc(sizeof(Lista));
temp->info=m;
temp->next=l;
return temp;
}

int min(Lista *l, int m) /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/

{
 int trovato=1;
if(l!=NULL)
{ 
if(l->info<m)
{trovato=0;}
else{trovato=min(l->next,m);}
  }
return trovato;
}

void stampa(Lista *l)
{
if(l!=NULL)
{printf("\n%d\n", l->info);
 stampa(l->next);
}
}

Lista *crea_lista()
{ 
 Lista *p, *punt;
int i,n;
printf("\nspecificare il numero degli elementi\n");
scanf("%d", &n);
 if(n==0)
 p=NULL;
 
else
 {
p=(Lista*)malloc(sizeof(Lista));
printf("\ninserisci il primo valore\n");
scanf("%d", &p->info);
punt=p;
for(i=2;i<=n;i++)
{ 
 punt->next=(Lista*)malloc(sizeof(Lista));
 punt=punt->next;
 printf("\ninserisci il %d elemento ", i);
 scanf("%d", &punt->info);
}
punt->next=NULL;
} 
return p;
}
