#include <stdio.h>
#include <stdlib.h>

/*albero bilanciato*/

struct albero{ int label;
 struct albero *left;
 struct albero *right;

 };

typedef struct albero tree;

tree* crea_dx(tree *t); /*crea un nodo dx in modo bilanciato*/
tree* crea_sx(tree *t);/*crea un nodo sx in modo bilanciato*/
void stampa(tree *t); /*stampa l'albero da sinistra verso destra partendo dalla radice*/


int main()
{
 tree *t;
 int m,i;
printf("\ninserisci il numero di etichette da inserire\n");
scanf("%d",&m);
for(i=0;i<m;i++)
 {
 t=crea_sx(t);
 t=crea_dx(t);
 }
stampa(t);
 return 0;
}


void stampa(tree *t)
 {
if(t!=NULL)
 {
printf("\n%d\n", t->label);
stampa(t->left);
stampa(t->right);
 }
 
 }

tree* crea_dx(tree *t)
{
if(t==NULL)
 {
 t=malloc(sizeof(tree));
 printf("\ninserisci un'etichetta\n");
 scanf("%d",&t->label);
 t->left=NULL;
 t->right=NULL;
  }
else if (t->left==NULL) {t->left=crea_dx(t->left); }
else                    {t->right=crea_dx(t->right);}
return t;
 }

tree* crea_sx(tree *t)
{
if(t==NULL)
 {
 t=malloc(sizeof(tree));
 printf("\ninserisci un'etichetta\n");
 scanf("%d",&t->label);
 t->left=NULL;
 t->right=NULL;
  }
else if (t->right==NULL) {t->right=crea_sx(t->right); }
else                    {t->left=crea_sx(t->left);}
return t;
 }

