#include <stdioh>
#include <stdlib.h>

struct albero_binario{
 int label;
 struct albero_binario *left;
 struct albero_binario *right;
   };

typedef struct albero_binario albero;

void raddoppia_pari(albero a);/*raddoppia l'etichetta di nodi con etichetta pari*/
void visita_simmetrica(albero a);
void visita_anticipata(albero a);
void visita_posticipata(albero a);
int ricerca_etichetta(albero a, int m);

int ricerca_etichetta(albero a, int m)/*controlla se m appartiene all'albero*/
{
 int trovato=0;
 if(a!=NULL)
  { while(!trovato && a!=NULL)
  {if(a->label==m)
 trovato=1;
 else 
 {trovato=ricerca_etichetta(a->left,m);
 if(!trovato)
trovato=ricerca_etichetta(a->right,m);}
}
}
return trovato;

}

void visita_posticipata(albero a)
{
 if(a!=NULL)
{
 visita_posticipata(a->left);
 visita_posticipata(a->right);
 nodo(a->label);
}
}

void visita_anticipata(albero a)
{ if(a!=NULL)
{
nodo(a->label);
visita_anticipata(a->left);
visita_anticipata(a->right);
}
}

void visita_simmetrica(albero a)
{
 if(a!=NULL)
{ visita_simmetrica(a->left);
  nodo(a->label);/*funzione che opera sul nodo: se la funzione modifica l'etichetta serve void nodo(albero *a) con chiamata nodo(&(a->label))*/
   visita_simmetrica(a->right);
}
}


void raddoppia_pari(albero a)
{
 if(a!=NULL)
 {
  if(a->label%2==0)
{a->label=2*(a->label);}
raddoppia_pari(a->right);
raddoppia_pari(a->left);
 }
}
 
