#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define dim 15

//(tutte le stringhe sono senza spazi) vengono inserite in un albero binario non bilanciato M coppie personaggio-ID, viene poi creato un array di liste di dimensione N che contiene alla k-esima posizione la lista di vittime del personaggio con id k. dopo aver preso in input l'albero si prendono le N coppie di nomi da input, il primo è il personaggio al quale si vuole associare il secondo che è la sua vittima. ovvero si ricerca l'ID del primo nome inserito e si inserisce il secondo nome in testa a l[ID]. alla fine di questo secondo ciclo di chiede di inserire un nome e si stampa la lista dei personaggi che ha ucciso  



struct albero{ char personaggio[dim]; int ID; struct albero *right; struct albero *left; };
struct Lista{ char info[dim]; struct Lista *next;   };

typedef struct Lista lista;
typedef struct albero tree;

tree* add(tree *t, char *s, int id); //aggiunge un nodo all'albero t
lista* add1(lista *l, char *s);//aggiunge un nodo in testa alla lista l
void stampa(tree *t);
void stampa1(lista *l);
int ricerca(tree *t, char *s);//restituisce l'ID del personaggio di nome s presente nell'albero t


int main()
{
int x,M,m,id,k,N, num;
tree *t;
char s[dim],interr[dim], per[dim], vittima[dim];
lista **l; //array di liste

t=malloc(sizeof(tree));
t=NULL;
scanf("%d", &M);

for(m=0;m<M;m++)
{ scanf("%s", s); scanf("%d", &id); t=add(t,s,id);    }

stampa(t);
printf("\n\n");

scanf("%d", &N);
l=malloc(N*sizeof(lista*));

for(k=0;k<N;k++)
{ l[k+1]=malloc(sizeof(lista));  }

for(k=0;k<N;k++)
{ scanf("%s", per); x=ricerca(t,per); scanf("%s", vittima); l[x]=add1(l[x],vittima);  }

scanf("%s",interr);
num=ricerca(t,interr);
stampa1(l[num]);

return 0;
}



tree* add(tree *t, char *s, int id)
{
if (t==NULL) { t=malloc(sizeof(tree)); strcpy(t->personaggio,s); t->ID=id; t->right=NULL; t->left=NULL; return t;}
else if (strcmp(s,t->personaggio)>=0) {t->right= add(t->right,s,id); return t;}
else {t->left= add(t->left,s,id); return t;}
}

lista* add1(lista *l, char *s)
{ lista *temp;
  temp=malloc(sizeof(lista));
  strcpy(temp->info,s);
  temp->next=l;
  return temp;
  }


void stampa(tree *t)
{ if(t!=NULL)
 { printf("\n%s\n", t->personaggio); printf("%d", t->ID); stampa(t->right); stampa(t->left);  }

 }


void stampa1(lista *l)
{
 if(l!=NULL) { printf("\n%s\n", l->info); stampa1(l->next); }
}


int ricerca(tree *t, char *s)
{
 if(t!=NULL)
 {
 if(strcmp(s,t->personaggio)==0) { return t->ID;}
else if(strcmp(s,t->personaggio)>0) {return ricerca(t->right,s);}
else return ricerca(t->left,s);
 }
}
