#include <stdio.h>
#include <stdlib.h>

struct lista{ int info;
 struct lista *next;
};

/*prende due successioni di interi positivi terminate da un num negativo e le inserisce in due liste, realizzare funzione che fa l'intersezione ordinata delle due ossia senza ripetizioni e i valori sono in ordine crescente*/

typedef struct lista Lista;


int lunghezza(Lista *l);
int min(Lista *l, int m); /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/
void stampa(Lista *l);
Lista* inserisci_in_testa(Lista *l, int m);
Lista* ordina(Lista *l, int m);/*inserisce m nella l ordinatamente*/
Lista* intersezione(Lista *l1,Lista *l2);/*intersezione ordinata*/
int occorrenza(Lista *l, int m);/*restituisce 1 se m appartiene a l*/
Lista* elimina_doppie(Lista *l); /*elimina gli elementi presenti in più di una copia nella lista*/
Lista *inserisci_in_coda(Lista *l, int m);


int main()
{
Lista *l1, *l2, *l;
int m;
scanf("%d", &m);
l1=malloc(sizeof(Lista));
l1->info=m;
l1->next=NULL;
scanf("%d", &m);
while(m>=0)
{
l1=ordina(l1,m);
scanf("%d", &m);
}
scanf("%d", &m);
l2=malloc(sizeof(Lista));
l2->info=m;
l2->next=NULL;
scanf("%d", &m);
while(m>=0)
{
l2=ordina(l2,m);
scanf("%d", &m);
}
l1=elimina_doppie(l1);
l=intersezione(l1,l2);
stampa(l);
}

int occorrenza(Lista *l, int m)
{
 int trovato=0;
if(l!=NULL)
 { if(l->info==m){trovato=1;}
 else trovato=occorrenza(l->next,m);
 }
 return trovato;
}

Lista* intersezione(Lista *l1,Lista *l2) 
{
 Lista *l;
l=malloc(sizeof(Lista));
l=NULL;
while(l1!=NULL)
{ if(occorrenza(l2,l1->info)==1)
 {l=inserisci_in_coda(l,l1->info);
 l1=l1->next;}
else { l1=l1->next;}
}
return l;
}

Lista *inserisci_in_coda(Lista *l, int m)
{
  Lista *temp;
  if(l==NULL)
{ 
  temp=(Lista*)malloc(sizeof(Lista));
  temp->info=m;
  temp->next=NULL;
  return temp;
}
 else
 { 
 l->next=inserisci_in_coda(l->next,m);
 return l;
 }
}

Lista* inserisci_in_testa(Lista *l, int m)
{
Lista *temp=malloc(sizeof(Lista));
temp->info=m;
temp->next=l;
return temp;
}


int min(Lista *l, int m) /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/

{
 int trovato=1;
if(l!=NULL)
{ 
if(l->info<m)
{trovato=0;}
else{trovato=min(l->next,m);}
  }
return trovato;
}


int lunghezza(Lista *l)
{ 
 int m=0;
while(l!=NULL)
{
l=l->next;
m++;}
return m;
}



Lista* elimina_doppie(Lista *l) /*elimina gli elementi presenti in più di una copia nella lista*/
{

 Lista *temp;
 temp=malloc(sizeof(Lista));
if(l!=NULL) 
{temp->info=l->info;
 temp->next=malloc(sizeof(Lista));
 if(occorrenza(l->next,l->info)==0){temp->next=elimina_doppie(l->next);}
else{temp->next=elimina_doppie((l->next)->next);}
return temp;
}
else return NULL;

}




Lista* ordina(Lista *l, int m)
{
if(l!=NULL)
 {if(min(l,m)==1){l=inserisci_in_testa(l,m);}
else {l->next=ordina(l->next,m);}
}
else{l=malloc(sizeof(Lista));
l->info=m; l->next=NULL; }
return l;
}

void stampa(Lista *l)
{
if(l!=NULL)
{printf("\n%d\n", l->info);
 stampa(l->next);
}
}

