#include <stdlib.h>
#include <stdio.h>

//prende in ingresso un albero di interi, poi due elementi x e y e restituisce il lca tra x e y

struct tree{
 int chiave;
 struct tree *left;
 struct tree *right;
 };

typedef struct tree albero;

int lca(albero *a , int x, int y); //lowest common ancestor
albero* inserisci(albero *a, int k);
int trovato(albero *a, int m);

int main()
{
 int n,i,x,y,k;
 albero *a;
a=malloc(sizeof(albero));
a=NULL;
scanf("%d", &n);
for(i=1;i<=n;i++)
{
scanf("%d", &k);
a=inserisci(a,k);
}
scanf("%d",&x);
scanf("%d",&y);
printf("%d\n", lca(a,x,y));
}



albero* inserisci(albero *a,int k)
{
if(a==NULL)

{
 a=malloc(sizeof(albero));
 a->chiave=k;
 a->left=NULL;
 a->right=NULL;
return a;
 }
else if (k>=a->chiave)
{a->right=inserisci(a->right,k); return a;}

else {a->left=inserisci(a->left,k); return a;}

}



int lca(albero *a , int x, int y) //restituisce la chiave meno profonda comune a x e y
{
int nodo,max,min;
if(a!=NULL)
{
 if(x>y){max=x; min=y;}
 else if(x<y) {max=y; min=x;}
 else {return x; //sono sullo stesso ramo e sono uguali 
}

if(max>=a->chiave && min<a->chiave) //sono su rami distinti
{return a->chiave;}

else if(min>=a->chiave) // sono entrambi sul ramo destro
 { return lca(a->right,x,y); }

else //sono entrambi sul ramo sinistro
{return lca(a->left,x,y);} 

 }
}


