#include <stdio.h>
#include <stdlib.h>

/*operazioni su liste*/

struct lista{
 int info;
 struct lista *next;
};

typedef struct lista Lista;

Lista* cancella_primo(Lista *l);/*canella il primo elemento della lista*/
Lista* crea_nodo(Lista *l);
void stampa(Lista *l);
int trovato(Lista *l,int m);/*restituisce 1 se m appartiene a l e 0 altrim*/
Lista* prima_occorrenza(Lista *l, int m);/*cancella la prima occorrenza di m in l*/
Lista* tutte_occorrenze(Lista *l, int m);/*cancella tutte le occorrenze di m in l*/

int main()
{
 Lista *l;
 int n,i,m;/*numero di elementi,contatore,elemento da ricercare*/
 l=malloc(sizeof(Lista));
 l=NULL;
 printf("\ninserisci il numero di elementi della lista\n");
 scanf("%d",&n);
 for(i=0;i<n;i++)
{l=crea_nodo(l); }
printf("\ninserisci l'elemento da eliminare\n");
scanf("%d",&m);
l=tutte_occorrenze(l,m);
stampa(l);
return 0;
}


Lista* prima_occorrenza(Lista *l, int m)
{
if(l!=NULL)
 {
  if(l->info==m)
   {l=cancella_primo(l);}
else {l->next=prima_occorrenza(l->next,m);} 
return l;
 }
}


Lista* tutte_occorrenze(Lista *l, int m)
{
while(trovato(l,m)==1)
{l=prima_occorrenza(l,m); }
return l;
 }



Lista* crea_nodo(Lista *l)
{
if(l==NULL)
{l=malloc(sizeof(Lista));
 printf("\ninserire un elemento\n");
 scanf("%d",&(l->info));
 }
else {l->next=crea_nodo(l->next);}
return l;
}




int trovato(Lista *l, int m)
{
int found=0;
if(l!=NULL)
{
 if((l->info)==m)
{found=1;
return found;}
else return trovato(l->next,m); 
 }
 }


Lista* cancella_primo(Lista *l)
{
Lista *temp;
if(l!=NULL)
{
temp=malloc(sizeof(Lista));
temp=l;
l=l->next;
free(temp);
return l;
 } 
}

void stampa(Lista *l)
{
if(l!=NULL)
{printf("\n%d\n",l->info);
stampa(l->next); }
 }

