#include <stdio.h>
#include <stdlib.h>

struct lista{int info; struct lista *next;};

typedef struct lista Lista;

Lista* crealista();
Lista* cancella_primo(Lista *l);
Lista* prima_occorrenza(Lista *l, int m);
void stampalista(Lista *l);

int main()
{int n;
 Lista *l;
 l=crealista();
 printf("\ninserisci un intero\n");
 scanf("%d",&n);
 l=prima_occorrenza(l,n);
 stampalista(l);
}

Lista* crealista()
{
  Lista *p,*punt;
 int n,i;
printf("\ninserisci il numero di elementi da inserire nella lista\n");
scanf("%d", &n);
if(n==0)
p=NULL;
else {
p=malloc(sizeof(Lista));
printf("\ninserisci il primo elemento\n");
scanf("%d", &p->info);
p->next=NULL;
punt=p;
for(i=2;i<n+1;i++)
{
 punt->next=malloc(sizeof(Lista));
 punt=punt->next; 
 printf("\ninserisci il %d elemento\n", i);
 scanf("%d", &punt->info);
 }
punt->next=NULL;
}
return p;
}


void stampalista(Lista *l)
{
 if(l!=NULL)
{printf("\n%d\n", l->info);
stampalista(l->next);}
}

Lista* cancella_primo(Lista *l)
{
 Lista *temp;
 if(l!=NULL)
 {temp=malloc(sizeof(Lista));
 temp=l;
 l=l->next;
 free(temp);
 return l;}

}

Lista* prima_occorrenza(Lista *l, int m)/*cancella la prima occorrenza di m in l*/
{
 int trovato=0;
 Lista *prec,*corr; /*nodi che precedono e seguono il nodo da eliminare*/
 if(l!=NULL)
{
 if(l->info==m)
{l=cancella_primo(l); return l;}
else{ 
 prec=l;
 corr=prec->next;
 while (!trovato && corr!=NULL)
 { 
 if(corr->info==m){
trovato=1;
prec->next=corr->next;
free(corr);
 }
else {prec=prec->next;corr=corr->next;}
 }
}
return l; 
}
}
