#include <stdio.h>
#include <stdlib.h>
#define LUNG 10

void merge(int A[],int from,int mid,int to); /*fonde le due porzioni dell'array A con indici compresi tra from e mid e tra mid+1 e to*/
void mergeRicorsivo(int A[],int from, int to);
void mergeSort(int A[],int lung);

int main() /*prova di mergesort*/
{
int v[LUNG],i;
for(i=0;i<LUNG;i++)
scanf("%d", &v[i]);

mergeSort(v,LUNG);
printf("\n");
for(i=0;i<LUNG;i++)
printf("%d\n", v[i]);

return 0;

}


void merge(int A[],int from,int mid,int to)

{
int primo,secondo,appoggio,da_copiare, B[LUNG];
primo=from;
secondo=mid+1;
appoggio=from;

while(primo<=mid && secondo<=to) /*copia in modo ordinato gli elementi delle due porzioni fino all'esaurirsi di una delle due*/
{
if (A[primo]<=A[secondo])
  {
  B[appoggio]=A[primo];
  primo++;
  }
else
  {
  B[appoggio]=A[secondo];
  secondo++;
  }
appoggio++;
}

if(secondo>to) /*è finitaprima la 2* porzione, copia da A in B tutti gli elementi della prima porzione fino a mid*/

for(da_copiare=primo;da_copiare<=mid;da_copiare++)
{
B[appoggio]=A[da_copiare];
appoggio++;
}

else /*è finita prima la 1* porzione, copia da A in B tutti gli elementi della seconda porzione fino a to*/

for(da_copiare=secondo;da_copiare<=to;da_copiare++)
  {
  B[appoggio]=A[da_copiare];
  appoggio++;
  }
/*ricopia tutti gli elementi da from a to da B ad A*/

for(da_copiare=from;da_copiare<=to;da_copiare++)
A[da_copiare]=B[da_copiare];

}

void mergeRicorsivo(int A[],int from, int to)
{
int mid;
if (from<to)
{ mid=(from+to)/2;
  mergeRicorsivo(A,from,mid);
  mergeRicorsivo(A,mid+1,to);
  merge(A,from,mid,to);
}
}

void mergeSort(int A[],int lung)
{
mergeRicorsivo(A,0,lung-1);
}

