#include <stdio.h>
#include <stdlib.h>


struct lista{ 
 int info;
 struct lista *next;
 };

typedef struct lista Lista;


int min(Lista *l, int m);/*restituisce 1 se m è il minimo elemento della lista e 0 altrimenti */
Lista* ordinato(Lista *l, int m);/*inserisce m ordinatamente in l*/
Lista* inserisci_in_testa(Lista *l, int m);/*inserisce m in testa alla lista l*/
void stampa(Lista *l);


int main()
{
int m,n,i;
Lista *l;
l=malloc(sizeof(Lista));
l=NULL;
printf("\ninserisci il numero degli elementi da inserire in lista\n\n");
scanf("%d", &n);
for(i=0;i<n;i++)
 {
 printf("\ninserisci un elemento\n\n");
 scanf("%d", &m);
 l=ordinato(l,m);
  }
stampa(l);

return 0; 
}

void stampa(Lista *l)
{
if(l!=NULL)
 {
  printf("\n%d\n", l->info);
  stampa(l->next);
 } 
}


int min(Lista *l, int m)
{
int found=1;
while(l!=NULL&&found==1)
{
 if((l->info)<m){found=0;}
else { 
       l=l->next;
       found=min(l,m); 
      }
   }
return found;
 }



Lista* inserisci_in_testa(Lista *l, int m)
{
 Lista *temp;
 temp=malloc(sizeof(Lista));
 temp->info=m;
 temp->next=l;
 return temp;
 }

Lista* ordinato(Lista *l, int m)
{
 if(l==NULL) {l=inserisci_in_testa(l,m);}
else {
      if(min(l,m)==1) l=inserisci_in_testa(l,m);
      else l->next=ordinato(l->next,m);
     }
return l;
}
